<?php purchase_load_css(array("assets/css/purchase_style.css")); ?>
<div id="page-content" class="page-wrapper clearfix">
    <div class="card clearfix">
        <div class="page-title clearfix">
            <h4 class="no-margin font-bold"><i class="fa fa-clone menu-icon menu-icon" aria-hidden="true"></i> <?php echo ($title); ?></h4>

            <div class="title-button-group">
                <a href="<?php echo get_uri('purchase/vendor'); ?>" class="btn btn-default"><i data-feather='plus-circle' class='icon-16'></i>&nbsp;<?php echo app_lang('add_vendor'); ?></a>

                <a href="<?php echo get_uri('purchase/vendor_import'); ?>" class="btn btn-success pull-left display-block  mr-4 button-margin-r-b" title="<?php echo _l('import_vendors') ?> "><span data-feather="upload" class="icon-16"></span>
                    <?php echo _l('import_vendors'); ?>
                </a>
            </div>

        </div>
        <div class="table-responsive">
            <table id="monthly-vendor-table" class="display" cellspacing="0" width="100%">   
            </table>

  
        </div>
           
    </div>
</div>

<div class="modal bulk_actions" id="table_vendors_list_bulk_actions" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
     <div class="modal-content">
        <div class="modal-header">
           <h4 class="modal-title"><?php echo _l('bulk_actions'); ?></h4>
           <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
           <?php if(has_permission('purchase_vendors','','delete') || is_admin()){ ?>
           <div class="checkbox checkbox-danger">
              <input type="checkbox" name="mass_delete" id="mass_delete">
              <label for="mass_delete"><?php echo _l('mass_delete'); ?></label>
           </div>
          
           <?php } ?>
        </div>
        <div class="modal-footer">
           <button type="button" class="btn btn-default" data-bs-dismiss="modal"><?php echo _l('close'); ?></button>

           <?php if(has_permission('purchase_vendors','','delete') || is_admin()){ ?>
           <a href="#" class="btn btn-info" onclick="purchase_delete_bulk_action(this); return false;"><?php echo _l('confirm'); ?></a>
            <?php } ?>
        </div>
     </div>
    
  </div>
  
</div>

<script type="text/javascript">
    loadVendorsTable = function (selector) {

    var optionVisibility = false;

    $(selector).appTable({
    source: '<?php echo_uri("purchase/list_vendor_data") ?>',

            order: [[1, "desc"]],
            filterDropdown: [{name: "category_id", class: "w200", options: <?php echo view("Purchase\Views\\vendors\categories_dropdown"); ?>}],
            columns: [
            {title: '<span class="hide"> - </span><div class="checkbox mass_select_all_wrap"><input type="checkbox" id="mass_select_all" data-to-table="monthly-vendor-table" class="form-check-input"><label></label></div>', "class": "w10p"},    
            {title: "#ID", "class": "w10p"},
            {title: "<?php echo app_lang("company") ?>", "class": ""},
            {title: "<?php echo app_lang("primary_contact") ?>", "class": "w15p"},

            {title: "<?php echo app_lang("primary_email") ?>", "class": "w10p", "iDataSort": 3},

            {title: "<?php echo app_lang("phone") ?>", "class": "w10p", "iDataSort": 5},
            {title: "<?php echo app_lang("pur_date_created") ?>", "class": "w10p text-right"},
            {title: "<?php echo app_lang("pur_options") ?>", "class": "w10p text-right"}
            ],

    });
    };
    $(document).ready(function () {
    loadVendorsTable("#monthly-vendor-table", "monthly");

    $('.toolbar-left-top').append('<button class="btn btn-default column-show-hide-popover ml15" onclick="vendor_bulk_actions(); return false;" tabindex="0" type="button"><span><?php echo _l('bulk_actions'); ?></span></button>');
    });


$("body").on("change", "#mass_select_all", function () {
var to, rows, checked;
to = $(this).data("to-table");

rows = $("#" + to).find("tbody tr");
checked = $(this).prop("checked");
$.each(rows, function () {
  $($(this).find("td").eq(0)).find("input").prop("checked", checked);
});
});


function vendor_bulk_actions(){
    "use strict";
    $('#table_vendors_list_bulk_actions').modal('show');
}


function purchase_delete_bulk_action(event) {
    "use strict";

    if (confirm_delete()) {
        var mass_delete = $('#mass_delete').prop('checked');

        if(mass_delete == true){
            var ids = [];
            var data = {};

            data.mass_delete = true;
            data.rel_type = 'vendors';

            var rows = $('#monthly-vendor-table').find('tbody tr');
            $.each(rows, function() {
                var checkbox = $($(this).find('td').eq(0)).find('input');
                if (checkbox.prop('checked') === true) {
                    ids.push(checkbox.val());
                }
            });

            data.ids = ids;
            $(event).addClass('disabled');
            setTimeout(function() {
                $.post("<?php echo get_uri("purchase/purchase_delete_bulk_action") ?>", data).done(function() {
                    window.location.reload();
                }).fail(function(data) {
                    $('#table_vendors_list_bulk_actions').modal('hide');
                    appAlert.warning(data.responseText);
                });
            }, 200);
        }else{
            window.location.reload();
        }

    }
}


// Will give alert to confirm delete
function confirm_delete() {
  var message = "Are you sure you want to perform this action?";

  // Clients area
  if (typeof app != "undefined") {
    message = app.lang.confirm_action_prompt;
  }

  var r = confirm(message);
  if (r == false) {
    return false;
  }
  return true;
}


</script>