<?php

defined('PLUGINPATH') or exit('No direct script access allowed');
use App\Controllers\Security_Controller;
use App\Libraries\Template;

/*
  Plugin Name: Purchase 
  Description: Purchase Management Module is a tool for managing your day-to-day purchases. It is packed with all necessary features that are needed by any business, which has to buy raw material for manufacturing or finished good purchases for trading
  Version: 1.0.0
  Requires at least: 3.0
  Author: GreenTech Solutions
  Author URI: https://codecanyon.net/user/greentech_solutions
 */

if(!defined('APP_MODULES_PATH')){
    define('APP_MODULES_PATH', FCPATH . 'plugins/');
}

if(!defined('EXT')){
    define('EXT', '.php');
}

if(!defined('PURCHASE_MODULE_NAME')){
    define('PURCHASE_MODULE_NAME', 'Purchase');    
}

if(!defined('PURCHASE_REVISION')){
    define('PURCHASE_REVISION', 10010);    
}
if(!defined('PURCHASE_MODULE_UPLOAD_FOLDER')){
    define('PURCHASE_MODULE_UPLOAD_FOLDER', 'plugins/Purchase/Uploads/');    
}

if(!defined('PURCHASE_IMPORT_VENDOR_ERROR')){
    define('PURCHASE_IMPORT_VENDOR_ERROR', 'plugins/Purchase/Uploads/import_vendor_error/');    
}

if(!defined('VENDOR_ERROR')){
        define('VENDOR_ERROR', FCPATH);    
    }   

app_hooks()->add_action('app_hook_head_extension', function (){
    $viewuri = $_SERVER['REQUEST_URI'];

    if (!(strpos($viewuri, '/purchase') === false)) {   
        echo '<script src="' . base_url('plugins/Purchase/assets/js/main/main.js').'?v=' . PURCHASE_REVISION.'"></script>';
        echo '<script src="' . base_url('plugins/Purchase/assets/plugins/signature_pad.min.js') . '"></script>';
    }
});
app_hooks()->add_action('app_hook_head_extension', function (){
    $viewuri = $_SERVER['REQUEST_URI'];
    $ci = new Security_Controller(false);

    if (!(strpos($viewuri, '/purchase') === false)) {   
        echo '<link href="' . base_url('plugins/Purchase/assets/css/main.css') .'?v=' . PURCHASE_REVISION. '"  rel="stylesheet" type="text/css" />';
    }

     if (!(strpos($viewuri, '/dashboard') === false) && isset($ci->login_user->user_type) && $ci->login_user->user_type == 'vendor') {  
         echo '<link href="' . base_url('plugins/Purchase/assets/css/main.css') .'?v=' . PURCHASE_REVISION. '"  rel="stylesheet" type="text/css" />';
     }

    if (!(strpos($viewuri, '/purchase/items') === false)) {
        echo '<link href="' . base_url('plugins/Purchase/assets/css/items/item_modal.css') .'?v=' . PURCHASE_REVISION. '"  rel="stylesheet" type="text/css" />';
        
    }
});


app_hooks()->add_filter('app_filter_email_templates', function($templates_array) {
    $templates_array['purchase'] = [
        'purchase_order_to_contact' => ['PO_NUMBER', 'PO_NAME', 'PO_TAX_VALUE', 'PO_SUBTOTAL', 'PO_VALUE', 'PO_LINK', 'ORDER_DATE', 'CONTACT_NAME'],
        'purchase_quotation_to_contact' => ['PQ_NUMBER', 'PQ_TAX_VALUE', 'PQ_SUBTOTAL', 'PQ_VALUE', 'PQ_LINK', 'DATE', 'EXPIRY_DATE', 'CONTACT_NAME'],
        'purchase_request_to_contact' => ['PR_NUMBER', 'PR_NAME', 'PR_TAX_VALUE', 'PR_SUB_TOTAL', 'PR_VALUE', 'PR_LINK' , 'CONTACT_NAME']
    ];

    return $templates_array;
});

app_hooks()->add_filter('app_filter_notification_config', function($events) {
    $view_pur_request_link = function ($options) {
        $url = "";
        if (isset($options->pur_request_id)) {
            $url = get_uri("purchase/view_pur_request/" . $options->pur_request_id);
        }

        return array("url" => $url);
    };

    $view_quotation_link = function ($options) {
        $url = "";
        if (isset($options->pur_quotation_id)) {
            $url = get_uri("purchase/view_quotation/" . $options->pur_quotation_id);
        }

        return array("url" => $url);
    };

    $view_pur_order_link = function ($options) {
        $url = "";
        if (isset($options->pur_order_id)) {
            $url = get_uri("purchase/view_pur_order/" . $options->pur_order_id);
        }

        return array("url" => $url);
    };

    $payment_invoice_link = function ($options) {
        $url = "";
        if (isset($options->pur_payment_id)) {
            $url = get_uri("purchase/payment_invoice/" . $options->pur_payment_id);
        }

        return array("url" => $url);
    };

 
    
    $events["notify_send_request_approve_pur_request"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_request_link
    ];

    $events["notify_send_approve_pur_request"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_request_link
    ];

    $events["notify_send_rejected_pur_request"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_request_link
    ];


    $events["notify_send_request_approve_pur_quotation"] = [
            "notify_to" => array("team_members"),
            "info" => $view_quotation_link
    ];

    $events["notify_send_approve_pur_quotation"] = [
            "notify_to" => array("team_members"),
            "info" => $view_quotation_link
    ];

    $events["notify_send_rejected_pur_quotation"] = [
            "notify_to" => array("team_members"),
            "info" => $view_quotation_link
    ];

    
    $events["notify_send_request_approve_pur_order"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_order_link
    ];

    $events["notify_send_approve_pur_order"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_order_link
    ];

    $events["notify_send_rejected_pur_order"] = [
            "notify_to" => array("team_members"),
            "info" => $view_pur_order_link
    ];


    $events["notify_send_request_approve_pur_inv"] = [
            "notify_to" => array("team_members"),
            "info" => $payment_invoice_link
    ];

    $events["notify_send_approve_pur_inv"] = [
            "notify_to" => array("team_members"),
            "info" => $payment_invoice_link
    ];

    $events["notify_send_rejected_pur_inv"] = [
            "notify_to" => array("team_members"),
            "info" => $payment_invoice_link
    ];

    return $events;
});

//add menu item to left menu
app_hooks()->add_filter('app_filter_client_left_menu', function($sidebar_menu) {

    $CI = new Security_Controller(false);

    $purchase_submenu = array();

    $purchase_submenu["vendor_profile"] = array(
        "name" => "profile", 
        "url" => "purchase/vendor/".get_vendor_user_id(), 
        "class" => "users"
    );
   

    $purchase_submenu["purchase_items"] = array(
        "name" => "items", 
        "url" => "purchase/vendor_portal_items", 
        "class" => "users"
    );
   
    $purchase_submenu["purchase_request"] = array(
        "name" => "purchase_request", 
        "url" => "purchase/purchase_request", 
        "class" => "users"
    );

    $purchase_submenu["quotations"] = array(
        "name" => "quotations", 
        "url" => "purchase/quotations", 
        "class" => "users"
    );

    $purchase_submenu["purchase_orders"] = array(
        "name" => "purchase_orders", 
        "url" => "purchase/purchase_orders", 
        "class" => "users"
    );

    $purchase_submenu["invoices"] = array(
        "name" => "invoices", 
        "url" => "purchase/invoices", 
        "class" => "users"
    );


    if($CI->login_user->user_type == 'vendor'){
        $sidebar_menu["purchase"] = array(
            "name" => "purchase",
            "url" => "purchase",
            "class" => "shopping-cart",
            "submenu" => $purchase_submenu,
            "position" => 5,

        );

        foreach ($sidebar_menu as $key => $menu) {
            if($key != 'purchase'){
                unset($sidebar_menu[$key]);
            }
        }
    }

    return $sidebar_menu;

});

app_hooks()->add_filter('app_filter_staff_left_menu', function ($sidebar_menu) {
    $purchase_submenu = array();

    $ci = new Security_Controller(false);
  
    if ($ci->login_user->is_admin || pur_has_permission('pur_access_items') || pur_has_permission('pur_access_vendors') || pur_has_permission('pur_access_vendor_items') || pur_has_permission('pur_can_view_own_purchase_request') || pur_has_permission('pur_can_view_global_purchase_request') || pur_has_permission('pur_can_view_global_purchase_quotation') || pur_has_permission('pur_can_view_own_purchase_order') || pur_has_permission('pur_can_view_global_purchase_order') || pur_has_permission('pur_can_view_global_purchase_invoice')) {

        if(pur_has_permission('pur_access_items')){
            $purchase_submenu["purchase_items"] = array(
                "name" => "items", 
                "url" => "purchase/items", 
                "class" => "users"
            );
        }
        
        if(pur_has_permission('pur_access_vendors')){
            $purchase_submenu["vendors"] = array(
                "name" => "vendors", 
                "url" => "purchase/vendors", 
                "class" => "users"
            );
        }

        if(pur_has_permission('pur_access_vendor_items')){
            $purchase_submenu["vendor_items"] = array(
                "name" => "vendor_items", 
                "url" => "purchase/vendor_items", 
                "class" => "newspaper"
            );
        }

        if(pur_has_permission('pur_can_view_own_purchase_request') || pur_has_permission('pur_can_view_global_purchase_request') ){
            $purchase_submenu["purchase_request"] = array(
                "name" => "purchase_request", 
                "url" => "purchase/purchase_request", 
                "class" => "users"
            );
        }

        if(pur_has_permission('pur_can_view_global_purchase_quotation')){
            $purchase_submenu["quotations"] = array(
                "name" => "quotations", 
                "url" => "purchase/quotations", 
                "class" => "users"
            );
        }

        if(pur_has_permission('pur_can_view_own_purchase_order') || pur_has_permission('pur_can_view_global_purchase_order') ){
            $purchase_submenu["purchase_orders"] = array(
                "name" => "purchase_orders", 
                "url" => "purchase/purchase_orders", 
                "class" => "users"
            );
        }

        if(pur_has_permission('pur_can_view_global_purchase_invoice') ){
            $purchase_submenu["invoices"] = array(
                "name" => "invoices", 
                "url" => "purchase/invoices", 
                "class" => "users"
            );
        }

        if($ci->login_user->is_admin){
            $purchase_submenu["settings"] = array(
                "name" => "settings", 
                "url" => "purchase/settings", 
                "class" => "setting"
            );
        }

        $sidebar_menu["purchase"] = array(
            "name" => "purchase",
            "url" => "purchase",
            "class" => "shopping-cart",
            "submenu" => $purchase_submenu,
            "position" => 5,

        );
    }

    return $sidebar_menu;

});



//install dependencies
register_installation_hook("Purchase", function ($item_purchase_code) {
    /*
     * you can verify the item puchase code from here if you want. 
     * you'll get the inputted puchase code with $item_purchase_code variable
     * use exit(); here if there is anything doesn't meet it's requirements
     */
    //include PLUGINPATH . "Purchase/lib/gtsverify.php";
    require_once(__DIR__ . '/install.php');
});

// Active action
register_activation_hook("Purchase", function ($item_purchase_code) {
       require_once(__DIR__ . '/install.php');
});

//uninstallation: remove data from database
register_uninstallation_hook("Purchase", function () {
    require_once __DIR__ . '/uninstall.php';
});


//update plugin
register_update_hook("Purchase", function () {
    require_once __DIR__ . '/install.php';
});

//uninstallation: remove data from database
register_uninstallation_hook("Purchase", function () {
    $dbprefix = get_db_prefix();
    $db = db_connect('default');

    $sql_query = "DROP TABLE IF EXISTS `" . $dbprefix . "purchase_settings`;";
    $db->query($sql_query);
});
/*app_hooks()->add_action('app_hook_purchase_init', function (){
    require_once __DIR__ .'/lib/gtsslib.php';
    $lic_purchase = new PurchaseLic();
    $purchase_gtssres = $lic_purchase->verify_license(true);    
    if(!$purchase_gtssres || ($purchase_gtssres && isset($purchase_gtssres['status']) && !$purchase_gtssres['status'])){
        echo '<strong>YOUR PURCHASE PLUGIN FAILED ITS VERIFICATION. PLEASE <a href="/index.php/Plugins">REINSTALL</a> OR CONTACT SUPPORT</strong>';
        exit();
    } 
});
app_hooks()->add_action('app_hook_uninstall_plugin_Purchase', function (){
    require_once __DIR__ .'/lib/gtsslib.php';
    $lic_purchase = new PurchaseLic();
    $lic_purchase->deactivate_license();    
});*/
